﻿using Caliburn.Micro;
using RibbonApplication.ViewModels;
using System;
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace RibbonApplication
{
   class Bootstrapper : BootstrapperBase
   {
      public Bootstrapper()
      {

         Initialize();
      }

      protected override void OnStartup(object sender, StartupEventArgs e)
      {
         
         DisplayRootViewFor<MainViewModel>();
      }

      protected override void OnExit(object sender, EventArgs e)
      {
         System.GC.Collect();

         base.OnExit(sender, e);
      }

      private CompositionContainer container;

      protected override void Configure()
      {
         //An aggregate catalog that combines multiple catalogs  
         var catalog = new AggregateCatalog();

         //Adds all the parts found in the same assembly as the Program class  
         catalog.Catalogs.Add(new AssemblyCatalog(typeof(Bootstrapper).Assembly));

         //Create the CompositionContainer with the parts in the catalog  
         container = new CompositionContainer(catalog);

         var batch = new CompositionBatch();
         batch.AddExportedValue(container);

         container.Compose(batch);
      }




   }
}
